@echo off


:: This script is used to run the test client applications.
:: Call this script with the name of the client application you wish
:: to run.
::          ex: ./runtest.sh GetApplicationListTest
::          ex: ./runtest.sh GetApplicationTest GRANT00012345
::          ex: ./runtest.sh AssignAgencyTrackingNumTest GRANT00012345 abc123
::
:: Listed below are test names that you can run.
::
:: GetApplicationListTest 
:: AssignAgencyTrackingNumTest [GRANTxxxxxxxx] [AgencyTrackingNumber]
:: ConfirmApplicationDeliveryTest [GRANTxxxxxxxx]
:: GetApplicationTest [GRANTxxxxxxxx]
:: GetApplicationZipTest [GRANTxxxxxxxx]
:: SaveAdobeOpportunityTest [C:/path/to/myOpportunityXml.xml]
:: DeleteAdobeOpportunityTest [OPPORTUNITY NUMBER] [AGENCY ID IN OPPORTUNITY XML]
:: DeleteAdobeSynopsisTest [OPPORTUNITY NUMBER] [AGENCY ID IN OPPORTUNITY XML]


:: Variables that you should change to suit your environment.

set JAVA_HOME=..\..\jdk1.5.0_11
:: Enclose value in double quotes in case a space is present in directory path
echo JAVA_HOME=%JAVA_HOME%

set REFIMPL=..\..\AgencyClient
echo REFIMPL=%REFIMPL%
echo.
echo.
echo.

set DIST_DIR=%REFIMPL%\dist
echo DIST_DIR=%DIST_DIR%
echo.
echo.
echo.

set LIB=%REFIMPL%\lib
set CLIENTJAR=%REFIMPL%\dist\agency-s2s-client.jar
echo Client Jar: %CLIENTJAR%


:: Variable that you don't need to change.

set PACKAGE=gov.grants.apply.agency
set JAVAOPTS=-Djava.protocol.handler.pkgs=com.sun.net.ssl.internal.www.protocol
:: JAVAOPTS=%JAVAOPTS% -Djavax.net.debug=ssl,handshake

echo JAVAOPTS=%JAVAOPTS%


echo Creating a classpath from the contents of your lib directory ...
echo.
echo.

:: FOR /D %%G IN ( %LIB%, %LIB%/temp ) DO echo **Listing contents of %%G***& dir "%%G"\*.jar


:: dynamically set classpath
set MYCP=
FOR %%i IN ( %LIB%\*.*, %LIB%\temp\*.* ) DO call classpathAppend.bat %%i

set MYCP=%MYCP%;%CLIENTJAR%;%DIST_DIR%
echo.
echo.
echo MYCP=%MYCP%

echo.
echo param 1=%1
echo param 2=%2
echo param 3=%3
echo.

:: Use WSTestClient as the default application to run if no arguments were provided.

IF %1 == "" GOTO setDefaultClass
GOTO setClass

:setDefaultClass
echo Setting default class to run
set CLASS=%PACKAGE%.WSTestClient
GOTO endSetClass

:setClass
echo Setting class [ %1 ] to run
set CLASS=%PACKAGE%.%1

:endSetClass

echo.
echo Running %CLASS%
echo.


:: Run the test application with all other arguments after the first.

set CLASSPATH=%MYCP%
:: CLASSPATH=%CLASSPATH%%CP_SEP%%REFIMPL%\config
:: export CLASSPATH
echo classpath: %CLASSPATH%

:: echo %JAVA_HOME%\bin\java -classpath %MYCP% %JAVAOPTS% %CLASS% %@
:: %JAVA_HOME%\bin\java -classpath %MYCP% %JAVAOPTS% %CLASS% %@
echo.
echo.
echo RUNNING --- %JAVAOPTS% %CLASS% %2 %3
echo.

:: GOTO EndComment

%JAVA_HOME%\bin\java %JAVAOPTS% %CLASS% %2 %3

:EndComment

