/*
 * Created on Sep 27, 2005
 *
 * Unpublished Work, Copyright, 2005 Northrop Grumman
 */
package gov.grants.apply.agency;

import gov.grants.apply.WebServices.AgencyIntegrationServices_V1_0.AssignAgencyTrackingNumberRequest;
import gov.grants.apply.WebServices.AgencyIntegrationServices_V1_0.AssignAgencyTrackingNumberResponse;

import java.rmi.RemoteException;
import java.util.Date;

import javax.xml.rpc.ServiceException;

import junit.framework.Assert;
import junit.framework.TestSuite;
import junit.textui.TestRunner;

import org.apache.log4j.Logger;

/**
 * @author Grants.gov WebServices Team
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class AssignAgencyTrackingNumTest extends AgencyWebServiceTestCase
{
   private static final Logger LOG = Logger.getLogger(AssignAgencyTrackingNumTest.class);
   
   private static String grantsGovTrackingNumber;   
   private static String agencyTrackingNumber;    
   
   /**
    * @param name
    */
   public AssignAgencyTrackingNumTest(String name)
   {
      super(name);
   }

   public static void main(String[] args)
   {
      if (args.length > 0)
      {
			grantsGovTrackingNumber = args[0];
			
			if (args.length > 1){
				agencyTrackingNumber  = args[1];
			}
			LOG.debug("Will run assignTrackingNumber() for " + grantsGovTrackingNumber + "; Agency Tracking Number: " + agencyTrackingNumber );
	    	   
			TestSuite suite = new TestSuite();
		    suite.addTest(new AssignAgencyTrackingNumTest("testAssignTrackingNumber"));     	  
//         TestSuite suite = new TestSuite();
//         for (int i = 0; i < args.length; i++)
//         {
//            LOG.info("Will run " + args[i]);
//            suite.addTest(new AssignAgencyTrackingNumTest(args[i]));
//         }
         TestRunner.run(suite);
      }
      else
      {
         LOG.info("Will run all tests.");
         TestRunner.run(AssignAgencyTrackingNumTest.class);
      }
   }
   
   public void testAssignTrackingNumber()
   {
	   

      try
      {
    	  
    	  String govTrackingNum;
          if (grantsGovTrackingNumber != null) {
        	  govTrackingNum = grantsGovTrackingNumber;
          } else {
        	  govTrackingNum = GetApplicationListTest.getExistingTrackingNumber(this);
          }
 
    	  String agencyTrackingNum;          
          if (agencyTrackingNumber != null) {
        	  agencyTrackingNum = agencyTrackingNumber;
          } else {
        	  agencyTrackingNum = getNewNumber();
          }
              	 
    	 LOG.debug("Assigning Agency Tracking Number for existing tracking number: " + govTrackingNum);
         assignTrackingNumber(govTrackingNum, agencyTrackingNum);
      }
      catch (RemoteException e)
      {
         LOG.fatal("Failed to invoke AssignAgencyTrackingNumber call.", e);
         Assert.fail(e.getMessage());
      }
   }
   
   public void testAssignTrackingNumberWithBlankAgencyNum()
   {
      try
      {
         assignTrackingNumber(GetApplicationListTest.getExistingTrackingNumber(this), "");
      }
      catch (RemoteException e)
      {
         if (LOG.isDebugEnabled())
         {
            LOG.debug("Excepted exception for blank agency number: " + e.getMessage());
         }
      }
   }
   
   public void testAssignTrackingNumberWithBadGrantsNum()
   {
      try
      {
         assignTrackingNumber("Bad Number", getNewNumber());
      }
      catch (RemoteException e)
      {
         LOG.debug("Excepted exception for bad grants.gov number: " + e.getMessage());
      }
   }
   
   public void testAssignTrackingNumberWithBlankGrantsNum()
   {
      try
      {
         assignTrackingNumber("", getNewNumber());
      }
      catch (RemoteException e)
      {
         LOG.debug("Excepted exception for blank grants.gov number: " + e.getMessage());
      }
   }
   
   private String getNewNumber()
   {
      return "AGENCY" + Long.toString(new Date().getTime());
   }
   
   private void assignTrackingNumber(String grantsTrackNumber, String agencyTrackNumber)
      throws RemoteException
   {
      AssignAgencyTrackingNumberRequest request = new AssignAgencyTrackingNumberRequest(grantsTrackNumber, agencyTrackNumber);
      AssignAgencyTrackingNumberResponse response = null;
      try
      {
         response = getPort().assignAgencyTrackingNumber(request);
      }
      catch (ServiceException e)
      {
         LOG.fatal("Unable to get port.", e);
         Assert.fail("Unable to get port.");
      }
      LOG.debug("The tracking number '" + agencyTrackNumber + "' was assigned to application " + response.getGrants_govTrackingNumber());
   }
}
