/*
 * Created on Sep 14, 2005
 *
 * Unpublished Work, Copyright, 2005 Northrop Grumman
 */
package gov.grants.apply.agency;

import gov.grants.apply.WebServices.AgencyIntegrationServices_V1_0.ConfirmApplicationDeliveryRequest;
import gov.grants.apply.WebServices.AgencyIntegrationServices_V1_0.ConfirmApplicationDeliveryResponse;

import java.rmi.RemoteException;

import javax.xml.rpc.ServiceException;

import junit.framework.Assert;
import junit.framework.TestSuite;
import junit.textui.TestRunner;

import org.apache.log4j.Logger;

/**
 * @author Grants.gov WebServices Team
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class ConfirmApplicationDeliveryTest extends AgencyWebServiceTestCase
{
   private static Logger LOG = Logger.getLogger(ConfirmApplicationDeliveryTest.class);
   
   private static String grantsGovTrackingNumber;   
   
   /**
    * @param name
    */
   public ConfirmApplicationDeliveryTest(String name)
   {
      super(name);
   }

   public static void main(String[] args)
   {
      if (args.length > 0)
      {
    	  
			grantsGovTrackingNumber = args[0];
			LOG.debug("Will run confirmApplication() for " + grantsGovTrackingNumber);
	    	   
			TestSuite suite = new TestSuite();
		    suite.addTest(new ConfirmApplicationDeliveryTest("testConfirmApplication"));    	  
//         TestSuite suite = new TestSuite();
//         for (int i = 0; i < args.length; i++)
//         {
//            LOG.info("Will run " + args[i]);
//            suite.addTest(new ConfirmApplicationDeliveryTest(args[i]));
//         }
		    TestRunner.run(suite);
      }
      else
      {
         LOG.info("Will run all tests.");
         TestRunner.run(ConfirmApplicationDeliveryTest.class);
      }
   }
   
   public void testConfirmApplication()
   {
	  String trackingNum;
      if (grantsGovTrackingNumber != null) {
    	  trackingNum = grantsGovTrackingNumber;
      } else {
    	  trackingNum = GetApplicationListTest.getExistingTrackingNumber(this);
      }
      
      try
      {
         confirmApplication(trackingNum);
      }
      catch (RemoteException e)
      {
         LOG.fatal("Could not confirm application", e);
         Assert.fail("Could not confirm application");
      }
      
      // Reset
      grantsGovTrackingNumber = null;      
   }
   
   public void testConfirmApplicationWithBadTrackingNum()
   {
      String trackingNumber = "bad number";
      try
      {
         confirmApplication(trackingNumber);
      }
      catch (RemoteException e)
      {
         // expected.
         LOG.debug("Expected expection from bad tracking number test." + e.getMessage());
      }
   }
   
   public void testConfirmApplicationWithBlankTrackingNum()
   {
      String trackingNumber = "";
      try
      {
         confirmApplication(trackingNumber);
      }
      catch (RemoteException e)
      {
         // expected.
         LOG.debug("Expected expection from blank tracking number test." + e.getMessage());
      }
   }
   
   private void confirmApplication(String trackingNum)
      throws RemoteException
   {
      ConfirmApplicationDeliveryRequest request = new ConfirmApplicationDeliveryRequest();
      request.setGrants_govTrackingNumber(trackingNum);
      ConfirmApplicationDeliveryResponse response = null;
      try
      {
         response = getPort().confirmApplicationDelivery(request);
      }
      catch (ServiceException e)
      {
         LOG.fatal("Could not get SOAP port.", e);
         Assert.fail("Could not get SOAP port.");
      }
      if (LOG.isDebugEnabled())
      {
         LOG.debug("Confirmation of '" + trackingNum + "': " + response.getResponseMessage().getValue());
      }
   }
   
}
