/*
 * Created on July 9, 2008
 *
 * Copyright, 2008 General Dynamics IT
 */
package gov.grants.apply.agency;

import gov.grants.apply.WebServices.AgencyIntegrationServices_V1_0.DeleteAdobeOpportunityRequest;
import gov.grants.apply.WebServices.AgencyIntegrationServices_V1_0.DeleteAdobeOpportunityResponse;

import java.rmi.RemoteException;

import javax.xml.rpc.ServiceException;

import junit.framework.Assert;
import junit.framework.TestSuite;
import junit.textui.TestRunner;

import org.apache.commons.lang.StringUtils;
import org.apache.log4j.Logger;

/**
 * @author Grants.gov WebServices Team
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class DeleteAdobeOpportunityTest extends AgencyWebServiceTestCase {
	private static final Logger log = Logger.getLogger( DeleteAdobeOpportunityTest.class );
	
	private static String OPP_NUM = null;
	private static String USER_ID = null;
	
   /**
    * @param name
    */
	public DeleteAdobeOpportunityTest( String name ) {
		super( name );
	}

	public static void main( String[] args ) {
		if ( args.length > 1 ) {
			OPP_NUM = args[0];
			log.debug( "Opportunity number=" + OPP_NUM );
			if ( StringUtils.isBlank( OPP_NUM ) ) {
				Assert.fail( "Opportunity number required" );
			}// if
			
			USER_ID = args[1];
			log.debug( "userID=" + USER_ID );
			
			TestSuite suite = new TestSuite();
		    suite.addTest( new DeleteAdobeOpportunityTest( "testDeleteAdobeOpportunity" ) );    	  
		    TestRunner.run( suite );
		} else {
			String msg = "BOTH Opportunity number and userID from opportunity XML required";
			log.info( msg );
			Assert.fail( msg );
		}// if-else
	}// main()
   
	public void testDeleteAdobeOpportunity() {
		try {
			deleteAdobeOpportunity( OPP_NUM, USER_ID );
		} catch (RemoteException e) {
			log.fatal( "DeleteAdobeOpportunity web service call failed:", e );
			Assert.fail( "DeleteAdobeOpportunity web service call failed: " + e.getMessage() );
		}// try-catch
		
		// Reset
		OPP_NUM = null;
		USER_ID = null;
		
	}// testDeleteAdobeOpportunity()
	
	
	private void deleteAdobeOpportunity( String oppNum, String userID )
	throws RemoteException {
		DeleteAdobeOpportunityRequest request = new DeleteAdobeOpportunityRequest();
		request.setOpportunityNumber( oppNum );
		if ( StringUtils.isNotBlank( userID ) ) {
			request.setUserID( userID );
		}// if
		
		DeleteAdobeOpportunityResponse response = null;
		try {
			log.debug( "Request to delete opportunity:" + oppNum );
			response = getPort().deleteAdobeOpportunity( request );
			log.debug( "--- response=" + response );
			log.debug( "--- opportunity number=" + response.getOpportunityNumber() );
			log.debug( "--- response message=" + response.getResponseMessage() );
		} catch ( ServiceException e ) {
			log.fatal( "Could not get SOAP port:", e );
			Assert.fail( "Could not get SOAP port: " + e.getMessage() );
		} catch ( Exception e ) {
			log.fatal( "Exception caught:" + e.getMessage() );
			Assert.fail( "Exception caught:" + e.getMessage() );
		}// try-catch
		
	}// deleteAdobeOpportunity()
   
}
