/*
 * Created on Feb 3, 2006
 *
 * Unpublished Work, Copyright, 2005, 2006 Northrop Grumman
 */
package gov.grants.apply.util;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.InputStream;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

import org.apache.log4j.Logger;
import org.apache.xml.serialize.OutputFormat;
import org.apache.xml.serialize.XMLSerializer;
import org.w3c.dom.Document;
import org.xml.sax.SAXException;

/**
 * @author david.wong2@ngc.com, Grants.gov Team 
 *
 * Utilities class for DOM activities.
 */
public final class DOMUtils
{
   private static final Logger LOG = Logger.getLogger(DOMUtils.class);

   public static final Document createDocument(String xml, boolean namespaceAware, boolean validating)
      throws SAXException, IOException, ParserConfigurationException
   {
      ByteArrayInputStream stream = new ByteArrayInputStream(xml.getBytes());
      return createDocument(stream, namespaceAware, validating);      
   }

   
   public static final Document createDocument(InputStream stream, boolean namespaceAware, boolean validating)
      throws SAXException, IOException, ParserConfigurationException
   {
      DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
      factory.setNamespaceAware(namespaceAware);
      factory.setValidating(validating);
      DocumentBuilder builder = factory.newDocumentBuilder();
      return builder.parse(stream);
   }

   public static final String serializeDocument(Document doc)
      throws IOException
   {
      ByteArrayOutputStream stream = new ByteArrayOutputStream();
      XMLSerializer serializer = new XMLSerializer();
      serializer.setOutputByteStream(stream);
      OutputFormat format = new OutputFormat(doc);
      format.setPreserveSpace(true);
      serializer.setOutputFormat(format);
      serializer.serialize(doc);
      return stream.toString();
   }
   
}
