/*
 * Created on Feb 17, 2006
 *
 * Unpublished Work, Copyright, 2005, 2006 Northrop Grumman
 */
package gov.grants.common.sql;

/**
 * @author david.wong2@ngc.com, Grants.gov Team 
 *
 * TODO Add description.
 */
public class WhereCondition implements SQLString
{
   private SQLString _operand1 = null;   
   private SQLString _operand2 = null;
   private String _operator = null;
   
   private WhereCondition(String operator, SQLString operand1, SQLString operand2)
   {
      _operator = operator;
      _operand1 = operand1;
      _operand2 = operand2;
   }
   
   public static WhereCondition createEquals(SQLString operand1, SQLString operand2)
   {
      return new WhereCondition("=", operand1, operand2);
   }
   
   public static WhereCondition createNotEquals(SQLString operand1, SQLString operand2)
   {
      return new WhereCondition("<>", operand1, operand2);
   }
   
   public static WhereCondition createLessThan(SQLString operand1, SQLString operand2)
   {
      return new WhereCondition("<", operand1, operand2);
   }
   
   public static WhereCondition createGreaterThan(SQLString operand1, SQLString operand2)
   {
      return new WhereCondition(">", operand1, operand2);
   }
   
   public static WhereCondition createLessOrEquals(SQLString operand1, SQLString operand2)
   {
      return new WhereCondition("<=", operand1, operand2);
   }
   
   public static WhereCondition createGreaterOrEquals(SQLString operand1, SQLString operand2)
   {
      return new WhereCondition(">=", operand1, operand2);
   }

   public static WhereCondition createLike(SQLString operand1, Literal operand2)
   {
      return new WhereCondition("LIKE", operand1, operand2);
   }

   public static WhereCondition createIsNull(Table.Column operand)
   {
      return new WhereCondition("IS", operand, Literal.NULL_LITERAL);
   }
   
   public static WhereCondition createIsNotNull(Table.Column operand)
   {
      return new WhereCondition("IS NOT", operand, Literal.NULL_LITERAL);
   }
   
   public StringBuffer addString(StringBuffer buffer)
   {
      return _operand2.addString(_operand1.addString(buffer).append(" ").append(_operator).append(" "));
   }
}
